{
cout <<" Reset the memory"<<endl;
gROOT->Reset();

cout <<"Create CanvMan"<<endl;
gROOT->ProcessLine(".L TDCanvMan.cc++");

cout <<"Create CanvMan"<<endl;
TDCanvMan * CanvMan= new TDCanvMan("ImpFitout.ps","ImpactFit");
gROOT->ProcessLine(".L TDImpFit.cc++");

cout <<"Read in hist from file"<<endl;
TFile* f= new TFile("d0.root","read");
cout<<"File check: "<<f->GetSize()<<endl;
TH1F *ImpHist((TH1F*)f->Get("d0_D0_0;1"));
ImpHist->SetDirectory(0);
f->Close();
cout <<"HistIntegral Check:"<<ImpHist->Integral()<<endl;

cout <<"StartFitter"<<endl;
TDImpFit* ImpFitGo = new TDImpFit(ImpHist,ImpHist->GetMaximum(),0.01,0.002,0.002,0.85);
//TDImpFit* ImpFitGo::_this=ImpFitGo;
ImpFitGo->SetTDCanvMan(CanvMan);
ImpFitGo->DoInitialFit();
ImpFitGo->PrintParameters();
ImpFitGo->DoFinalFit();
ImpFitGo->PrintParameters();

cout <<"EndFitter"<<endl;

//delete ImpFitGo;
delete CanvMan;
}
