#include "TDCanvMan.hh"

  /*TDCanvMan::TDCanvMan(const TDCanvMan& rhs)
  {
    _FileName=rhs._FileName;
    _Desc=rhs._Desc;
    //Have abandoned writing functions for copying, they should not be used!
    //each canvas should be unique, might implement copying later if wanted
    //to use sections of one canvas in another.
  }*/
  TDCanvMan::TDCanvMan()
   :_FileName("output.ps"),
    _Desc("DefaultDesc"),
    _PadWidth(2),
    _PadHeight(4)
  {
    char buffer[50];
    sprintf(buffer,"%p",&_c1);//the canvas has the name of it's pointer to avoid clashes in root
    _c1 = new TCanvas(buffer,_Desc.c_str(),600,800);
    sprintf(buffer,"%s[",_FileName.c_str());
    _c1->Print(buffer);
    _CanvPos=0;
    SetCanvsStyle();
    _c1->Divide(_PadWidth,_PadHeight,0.005,0.005); 
  }

  TDCanvMan::TDCanvMan(const char * FileName, const char * Desc)
    :_FileName(FileName),
     _Desc(Desc),
     _PadWidth(2),
     _PadHeight(4)
  {
    char buffer[50];
    sprintf(buffer,"%p",&_c1);//the canvas has the name of it's pointer to avoid clashes in root
    _c1 = new TCanvas(buffer,_Desc.c_str(),600,800);
    sprintf(buffer,"%s[",_FileName.c_str());
    _c1->Print(buffer);
    _CanvPos=0;
    SetCanvsStyle();
    _c1->Divide(_PadWidth,_PadHeight,0.005,0.005); 
  }
  
  /*void TDCanvMan::swap(TDCanvMan& rhs)//no &!
  {
    std::swap(_FileName,rhs._FileName);
    std::swap(_Desc,rhs._Desc);
    //see comment in copy constructor
  }*/

  /*TDCanvMan* TDCanvMan::clone()
  {
    return new TDCanvMan(*this);
    //see comment in copy constructor
  }*/

  /*TDCanvMan& TDCanvMan::operator=(const TDCanvMan& rhs)
  {
    if(this == &rhs)return *this;
    TDCanvMan temp(rhs);
    swap(temp);
    return *this;
    //see comment in copy constructor
  }*/

  TDCanvMan::~TDCanvMan() 
  {
    _c1->Draw();
    return;
    if(_CanvPos>0)_c1->Print(_FileName.c_str());
    std::cout<<"closing ps file"<<std::endl;
    char buffer[50];
    sprintf(buffer,"%s]",_FileName.c_str());
    _c1->Print(buffer);
  }

  void TDCanvMan::SetCanvsStyle()
  {
   char buffer[50];
   //TStyle * _MyStyle;
   sprintf(buffer,"%p",&_MyStyle);
   _MyStyle = new TStyle(buffer,"_MyStyle");
   _MyStyle->SetCanvasBorderMode(0);
   _MyStyle->SetCanvasBorderSize(0);
   _MyStyle->SetPadBorderMode(0);
   _MyStyle->SetStatBorderSize(0);   // was 1
   _MyStyle->SetPadColor(0);
   //_MyStyle->SetPadLeftMargin(0.05);
   //_MyStyle->SetPadRightMargin(0.05);
   _MyStyle->SetCanvasColor(0);
   _MyStyle->SetStatColor(10);
   //_MyStyle->SetOptStat(110010);
   _MyStyle->SetOptStat(0);
   _MyStyle->SetOptDate(0);
   _MyStyle->SetDateX(0.0);
   _MyStyle->SetDateY(0.0);
   _MyStyle->GetAttDate()->SetTextSize(0.02);
   _MyStyle->SetFrameBorderSize(1);  //-- seems to refer to the histograms
   _MyStyle->SetFrameFillColor(0);   //-- coloured background in histograms!
   _MyStyle->SetTitleColor(3);
   _MyStyle->SetTitleBorderSize(0);
   _MyStyle->SetTitleOffset(0.75);
   _MyStyle->SetTitleSize(1.5);
  // _MyStyle->SetTitleStyle(3016);
   //_MyStyle->SetVertical(kFalse);
   
   //_MyStyle->SetTitleFillColor(2);   //--- requires a very recent ROOT version
   gROOT->SetStyle(buffer);
   gROOT->ForceStyle();
   _c1->SetFillColor(0);
   //canvs->Divide(1,1,0.005,0.005);
   //canvs->SetTitle(" D analysis (5.3.3)");
   _c1->UseCurrentStyle(); 
  }

  void TDCanvMan::NextCanvasSlot()
  {
    _CanvPos++;
    if(_CanvPos>(_PadWidth*_PadHeight))
    {
      std::cout<<"new page"<<std::endl;
      _c1->Update();
      _CanvPos=1;
      _c1->Print(_FileName.c_str(),"Portrait");
      _c1->Clear();
      SetCanvsStyle();
      _c1->Divide(_PadWidth,_PadHeight,0.005,0.005);
    }   
    std::cout<<"new TPad: "<<_CanvPos<<std::endl;
    _c1->cd(_CanvPos);
    //gPad->SetVertical(kFALSE);
  }
